%{?mingw_package_header}

%define with_vss 1
%define qemu_version 3.1.0-rc0

Name: mingw-qemu-ga-win
Version: 101.2.0
Release: 1%{?dist}
Summary: Qemu's Guest agent for Windows

Group: System Environment/Daemons
License: GPLv2+ and LGPLv2+ and BSD
URL: http://www.qemu.org/
Requires(post): system-units
Requires(preun): systemd-units
Requires(postun): systemd-units
Source0: http://wiki.qemu.org/download/qemu-3.1.0-rc0.tar.bz2
Source1: build_configure.sh
%if %{with_vss}
Source2: VSSSDK72.tar.gz
%endif

Patch0001: 0001-Revert-osdep-Work-around-MinGW-assert.patch
Patch0002: 0001-Revert-qemu-ga-add-missing-libpcre-to-MSI-build.patch 
Patch0003: 0001-qga-fix-vendor-strings.patch
Patch0004: 0001-Change-Version-to-101.2.0.patch
Patch0005: 0001-qga-win-fix-leaks-of-build_guest_disk_info.patch
Patch0006: 0002-qga-Add-multiple-include-guard-to-guest-agent-core.h.patch
Patch0007: 0003-qga-update-guest-suspend-ram-and-guest-suspend-hybri.patch
Patch0008: 0004-error-Remove-NULL-checks-on-error_propagate-calls.patch
#Patch0009: 0005-build-sys-build-with-Vista-API-by-default.patch
#Patch0010: 0006-qga-drop-Vista-compatibility.patch
Patch0011: 0007-qemu-queue.h-simplify-reverse-access-to-QTAILQ.patch
Patch0012: 0008-qga-update-docs-with-systemd-suspend-support-info.patch
Patch0013: 0009-qga-win-Adding-support-for-Windows-Server-2019-get-o.patch
Patch0014: 0010-qga-win-include-glib-when-building-VSS-DLL.patch
Patch0015: 0011-qga-win-fix-VSS-build-breakage-due-to-unintended-gnu.patch
Patch0016: 0012-qga-Fix-guest-get-fsinfo-PCI-address-collection-in-W.patch
Patch0017: 0013-qga-process_event-simplification.patch
Patch0018: 0014-qga-Fix-mingw-compilation-warnings-on-enum-conversio.patch
Patch0019: 0015-Clean-up-ill-advised-or-unusual-header-guards.patch
Patch0020: 0016-Include-qemu-module.h-where-needed-drop-it-from-qemu.patch
Patch0021: 0017-Include-qemu-common.h-exactly-where-needed.patch
Patch0022: 0018-socket-Add-backlog-parameter-to-socket_listen.patch
Patch0023: 0019-qga-win-network-get-interfaces-command-name-field-bu.patch
Patch0024: 0020-qga-Add-guest-get-memory-block-info-to-blacklist.patch
Patch0025: 0021-qga-fence-guest-set-time-if-hwclock-not-available.patch
Patch0026: 0022-qga-Fix-guest-get-fsinfo-error-API-violations.patch
#Patch0027: 0023-qga-rename-Error-parameter-to-more-common-errp.patch
#Patch0028: 0024-qapi-Generate-command-registration-stuff-into-separa.patch
Patch0029: 0025-build-sys-clean-up-flags-included-in-the-linker-comm.patch
Patch0030: 0026-qga-qapi-schema.json-Fix-missing-in-GuestDiskBusType.patch
Patch0031: 0027-qga-qapi-schema.json-Fix-indent-level-on-doc-comment.patch
Patch0032: 0028-qga-qapi-schema.json-minor-format-fixups-for-rST.patch
#Patch0033: 0029-qga-Improve-error-report-by-calling-error_setg_win32.patch
#Patch0034: 0030-qga-Fix-a-memory-leak.patch
#Patch0035: 0031-qmp-constify-QmpCommand-and-list.patch
Patch0036: 0032-qga-Installer-Wait-for-installation-to-finish.patch
Patch0037: 0033-qga-win-Handle-VSS_E_PROVIDER_ALREADY_REGISTERED-err.patch
Patch0038: 0034-qga-win-prevent-crash-when-executing-guest-file-read.patch
Patch0039: 0035-qga-Fix-undefined-C-behavior.patch
Patch0040: 0036-qemu-ga-document-vsock-listen-in-the-man-page.patch
Patch0041: 0037-qga-commands-posix-fix-use-after-free-of-local_err.patch
Patch0042: 0038-Revert-prevent-crash-when-executing-guest-file-read-.patch
Patch0043: 0039-qga-Extract-guest_file_handle_find-to-commands-commo.patch
Patch0044: 0040-qga-Extract-qmp_guest_file_read-to-common-commands.c.patch
Patch0045: 0041-qga-Restrict-guest-file-read-count-to-48-MB-to-avoid.patch
Patch0046: 0042-qga-Fix-qmp_guest_get_memory_blocks-error-handling.patch
Patch0047: 0043-qga-Fix-qmp_guest_suspend_-disk-ram-error-handling.patch
Patch0048: 0044-qga-Plug-unlikely-memory-leak-in-guest-set-memory-bl.patch
Patch0049: 0045-error-Avoid-unnecessary-error_propagate-after-error_.patch
Patch0050: 0046-error-Eliminate-error_propagate-with-Coccinelle-part.patch
Patch0051: 0047-error-Eliminate-error_propagate-manually.patch
Patch0052: 0048-qga-win-Fix-QGA-VSS-Provider-service-stop-failure.patch
Patch0053: 0049-qga-fix-assert-regression-on-guest-shutdown.patch
#Patch0054: 0050-qga-Use-qemu_get_host_name-instead-of-g_get_host_nam.patch
Patch0055: 0051-qga-win-fix-guest-get-fsinfo-wrong-filesystem-type.patch
Patch0056: 0052-qga-qapi-schema-Document-1-for-invalid-PCI-address-f.patch
Patch0057: 0001-qga-add-command-guest-devices-for-reporting-Virtio-d.patch 

BuildArch: noarch

BuildRequires: automake
BuildRequires: autoconf
BuildRequires: libtool
BuildRequires: SDL-devel zlib-devel which texi2html gnutls-devel cyrus-sasl-devel
BuildRequires: glib2-devel
BuildRequires: gtk2-devel
BuildRequires: systemd
BuildRequires: python
BuildRequires: systemtap-sdt-devel
BuildRequires: perl-podlators
BuildRequires: texinfo
BuildRequires: gettext
BuildRequires: gettext-devel
BuildRequires: mingw32-pixman
BuildRequires: mingw64-pixman
BuildRequires: mingw32-gcc
BuildRequires: mingw64-gcc
BuildRequires: mingw32-pkg-config
BuildRequires: mingw64-pkg-config
BuildRequires: mingw32-glib2
BuildRequires: mingw64-glib2
BuildRequires: mingw32-glib2-static
BuildRequires: mingw64-glib2-static
BuildRequires: mingw32-gettext-static
BuildRequires: mingw64-gettext-static
BuildRequires: mingw32-winpthreads-static
BuildRequires: mingw64-winpthreads-static
BuildRequires: mingw64-zlib-static
BuildRequires: mingw32-zlib-static
BuildRequires: mingw64-headers
BuildRequires: mingw32-headers
BuildRequires: msitools >= 0.93.93
BuildRequires: flex
BuildRequires: bison

%description
qemu-kvm is an open source virtualizer that provides hardware emulation for
the KVM hypervisor.

This package provides an agent to run inside guests, which communicates
with the host over a virtio-serial channel named "org.qemu.guest_agent.0"

This package does not need to be installed on the host OS.

%package -n qemu-ga-win
Summary: %{summary}

%description -n qemu-ga-win
Qemu Guest Agent for Windows

%prep
%setup -q -n qemu-%{qemu_version}
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
#%patch0009 -p1 
#%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
#%patch0027 -p1
#%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
#%patch0033 -p1
#%patch0034 -p1
#%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
#%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%build

cp %{SOURCE1} build_configure.sh
%if %{with_vss}
   pwd
   tar -zxvf %{SOURCE2}
   ls VSSSDK72
%endif
#Build for Win32

./build_configure.sh \
   --cross-prefix=i686-w64-mingw32- \
   --enable-guest-agent-msi \
%if %{with_vss}
   --with-vss-sdk=%{_builddir}/qemu-%{qemu_version}/VSSSDK72 \
%endif
   --static || cat config.log

make qemu-ga

mkdir ../build_win32
cp qemu-ga.exe ../build_win32
cp qemu-ga-i386.msi ../build_win32

#Build for Win64

./build_configure.sh \
   --cross-prefix=x86_64-w64-mingw32- \
   --enable-guest-agent-msi \
%if %{with_vss}
   --with-vss-sdk=%{_builddir}/qemu-%{qemu_version}/VSSSDK72 \
%endif
   --static || cat config.log

make qemu-ga

mkdir ../build_win64
cp qemu-ga.exe ../build_win64
cp qemu-ga-x86_64.msi ../build_win64

rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{mingw32_bindir}
cp "../build_win32$MINGW_BUILDDIR_SUFFIX"/qemu-ga* $RPM_BUILD_ROOT%{mingw32_bindir}

mkdir -p $RPM_BUILD_ROOT%{mingw64_bindir}
cp "../build_win64$MINGW_BUILDDIR_SUFFIX"/qemu-ga* $RPM_BUILD_ROOT%{mingw64_bindir}

%files -n qemu-ga-win
%defattr(-,root,root)
%{mingw32_bindir}/qemu-ga*
%{mingw64_bindir}/qemu-ga*

%changelog
* Mon Aug 3 2020 Basil Salman <bsalman@redhat.com> 101.2.0
BZ#1746667 - [qemu-guest-agent]System reserve volume's file system via guest agent is different from it's in guest
BZ#1549425 - Getting response from guest-fsfreeze-thaw need about 90s sometimes 

* Thu Mar 5 2020 Basil Salman <bsalman@redhat.com> 101.1.0
BZ#1790455 - Add guest-get-devices command to qemu-ga-win

* Thu Oct 24 2019 Basil Salman <bsalman@redhat.com> 101.0.0
BZ#1733165 - QEMU Guest Agent For Windows Return Garbled NIC Name
BZ#1751431 - "guest-get-memory-block-info" is enabled but in fact it is not currently supported

* Tue Jan 22 2019 Yan Vugenfirer <yvugenfi@redhat.com> 100.0.0
BZ#1651655 -  Rebase mingw-qemu-ga-win to qemu 3.1. Change the versioning scheme to independent scheme for qemu-ga-win

* Mon Dec 24 2018 Sameeh Jubran <sjubran@redhat.com> 8.0.0
BZ#1645018 - CVE-2018-12617 virtio-win: Qemu: qemu-guest-agent: Integer overflow causes segmentation fault in qmp_guest_file_read()

* Sun Dec 23 2018 Sameeh Jubran <sjubran@redhat.com> 8.0.0
BZ#1659071 [RFE]Add "windows 2019 x64" support to OS reporting

* Thu Nov 08 2018 Sameeh Jubran <sjubran@redhat.com> 8.0.0
#rebase mingw-qemu-ga-win to qemu 3.1.0

* Sun Jun 24 2018 Sameeh Jubran <sjubran@redhat.com> 7.6.0
BZ#1565431 - "Disk" is [] in the result of guest-get-fsinfo cmd which is odd
BZ#1594113 - Error returned after issue {"execute":"guest-fstrim" } cmd for win7-32/64 and win2008-32/64/r2 guest
BZ#1536331 - Failed to upgrade qemu-ga without virtio-serial driver installed

* Wed Jan 24 2018 Sameeh Jubran <sjubran@redhat.com> 7.5.0
BZ#1536954 - Issuing guest-fsfreeze-freeze cmd for the first time on a new qemu-ga,can not get response.

* Wed Dec 13 2017 Sameeh Jubran <sjubran@redhat.com> 2.9.5
- Add resolved BZs to changelog
BZ#1514303 - QEMU Guest Agent VSS Provider service is being installed with startup type: Automatic
BZ#990629 - [Windows Guest Tools] QEMU Guest Agent service failed | After post-installation reboot another reboot is needed
BZ#1514382 - [guest-agent]Still can write to freezed file system after run "{ "execute": "guest-fsfreeze-freeze"}" cmd.
BZ#1071499 - qemu guest agent for Windows should support guest-set-time command
BZ#1082999 - [WGT] Win 2008 32bit: Detected circular dependencies demand starting RHEV Spice Agent.
BZ#1470649 - [virtio-win[qemu-ga-win][upstream]]Unable to install qemu-ga on Windows platform : QEMU guest agent -- Error 1722
BZ#1514347 - [qemu-ga-win] QEMU guest agent's version is not correct.
BZ#1515137 - Error window pops up during installing windows qemu-ga-win.msi manually

* Sun Jun 04 2017 Sameeh Jubran <sjubran@redhat.com> - 2.9.0
- First release
